=== debian/changelog ===
julia (0.4.5-3) unstable; urgency=medium

  * Disable ARM NEON extensions. (Closes: #820220)

 -- Graham Inggs <ginggs@debian.org>  Sun, 17 Apr 2016 13:35:42 +0200

julia (0.4.5-2) unstable; urgency=medium

  * Make rec_backtrace() always return 0 on ARM and PPC64,
    this avoids a FTBFS on armhf with recent GCC.

 -- Graham Inggs <ginggs@debian.org>  Thu, 07 Apr 2016 14:32:28 +0200

julia (0.4.5-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches, new fix-spelling-error-in-binary.patch.
  * Use libopenlibm instead of libm on powerpc and ppc64el.

 -- Graham Inggs <ginggs@debian.org>  Wed, 30 Mar 2016 17:56:56 +0200

julia (0.4.3-4) unstable; urgency=medium

  * Drop versioned build dependency on llvm-3.8-dev and
    build dependencies on libllvm3.x (no longer needed).
  * Upload to unstable.

 -- Graham Inggs <ginggs@debian.org>  Sun, 13 Mar 2016 11:06:39 +0200

julia (0.4.3-3) experimental; urgency=medium

  * Build depend on libllvm3.x as well (experimental).

 -- Graham Inggs <ginggs@debian.org>  Mon, 08 Feb 2016 13:06:53 +0200

julia (0.4.3-2) experimental; urgency=medium

  * Optionally build depend on llvm-3.8-dev (>= 1:3.8~+rc1).
  * Add debian/clean to fix FTBFSx2.
  * Migrate from julia-dbg to ddebs, bump debhelper build-dependency.
  * Bump Standards-Version to 3.9.7, no further changes.
  * Enable tests on i386 again.
  * Improve generated debug info to fix FTBFS on i386
    (see upstream issue #13754).

 -- Graham Inggs <ginggs@debian.org>  Mon, 08 Feb 2016 10:02:00 +0200

julia (0.4.3-1) unstable; urgency=medium

  [ Graham Inggs ]
  * Ensure pcre_h.jl and errno_h.jl are sorted reproducibly.

  [ Peter Colberg ]
  * Imported Upstream version 0.4.3
  * Refresh patches.
  * Drop patch fix-arm64-ftbfs.patch, no longer needed.
  * Update Vcs-Git and Vcs-Browser fields.
  * Fix lintian warning dh-exec-useless-usage.
  * Fix lintian warning spelling-error-in-binary.

 -- Peter Colberg <peter@colberg.org>  Thu, 14 Jan 2016 07:56:18 -0500

julia (0.4.2-3) unstable; urgency=medium

  * Fix FTBFS on arm64 (thanks to Edmund Grimley Evans). (Closes: #807701)
  * Disable tests on i386 until perfomance issue with LLVM >= 3.4
    is resolved (see upstream issue #14191).

 -- Graham Inggs <ginggs@debian.org>  Sat, 12 Dec 2015 11:27:26 +0200

julia (0.4.2-2) unstable; urgency=medium

  * Set number of parallel workers for tests.
    + Restart workers exceeding maximum resident memory size of 500 MiB.
  * Drop build depends on llvm-3.8-dev to permit migration to testing.
    (Closes: #803644)

 -- Peter Colberg <peter@colberg.org>  Thu, 10 Dec 2015 06:50:01 -0500

julia (0.4.2-1) unstable; urgency=medium

  * Imported Upstream version 0.4.2
  * Refresh patches.
  * Upload to unstable. (Closes: #803644)

 -- Peter Colberg <peter@colberg.org>  Mon, 07 Dec 2015 06:49:01 -0500

julia (0.4.1-2) experimental; urgency=medium

  * Build depend on libpcre2-dev >= 10.20-3~ to fix FTBFS on ppc64el.
  * Optionally build depend on llvm-3.8-dev to reduce performance regression.
  * Optionally build depend on llvm-3.6-dev to ease backporting.

 -- Peter Colberg <peter@colberg.org>  Wed, 02 Dec 2015 07:26:24 -0500

julia (0.4.1-1) experimental; urgency=medium

  * Imported Upstream version 0.4.1
  * Refresh patches.
  * Update debian/copyright.
  * Build depend on libsuitesparse-dev >= 1:4.4.5
  * Build depend on llvm-3.7-dev.
  * Build depend on libpcre2-dev (thanks to Matthew Vernon).
  * Disable libgit2 test to avoid dependency on libgit2.
  * Disable download test to avoid dependency on curl or wget.
  * Do not use home directory in tests.
  * Fix backtrace test with MCJIT.
  * Fix documentation spelling errors.
  * Install examples to doc directory inplace of symlink.

 -- Peter Colberg <peter@colberg.org>  Wed, 25 Nov 2015 08:00:20 -0500
