=== debian/tests/control ===
Test-Command: env JULIA_TEST_MAXRSS_MB=500 julia --check-bounds=yes -f -e "Base.runtests([\"all\"], max(CPU_CORES, 2))"
Restrictions: allow-stderr
